{
    "kind": "DeploymentConfig",
    "apiVersion": "apps.openshift.io/v1",
    "metadata": {
        "name": "jupyterhub",
        "namespace": "{{ meta.namespace }}",
        "labels": {
            "app": "jupyterhub"
        }
    },
    "spec": {
        "strategy": {
            "type": "Recreate",
            "recreateParams": {
              "timeoutSeconds": 1200
            }
        },
        "triggers": [
            {
                "type": "ConfigChange"
            }
        ],
        "replicas": 1,
        "selector": {
            "app": "jupyterhub",
            "deploymentconfig": "jupyterhub"
        },
        "template": {
            "metadata": {
                "annotations": {
                    "alpha.image.policy.openshift.io/resolve-names": "*"
                },
                "labels": {
                    "app": "jupyterhub",
                    "deploymentconfig": "jupyterhub"
                }
            },
            "spec": {
                "serviceAccountName": "jupyterhub-hub",
                "initContainers": [
                    {
                        "name": "wait-for-database",
                        "image": "jupyterhub:latest",
                        "command": [ "wait-for-database" ],
                        "resources": {
                            "limits": {
                                "memory": "{{ jupyterhub_memory }}"
                            }
                        },
                        "env": [
                            {
                                "name": "JUPYTERHUB_DATABASE_PASSWORD",
                                "value": "{{ db_password }}"
                            },
                            {
                                "name": "JUPYTERHUB_DATABASE_HOST",
                                "value": "jupyterhub-db"
                            }
                        ]
                    }
                ],
                "containers": [
                    {
                        "name": "jupyterhub",
                        "image": "jupyterhub-img:latest",
                        "ports": [
                            {
                                "containerPort": 8080,
                                "protocol": "TCP"
                            }
                        ],
                        "resources": {
                            "limits": {
                                "memory": "{{ jupyterhub_memory }}"
                            }
                        },
                        "env": [
                            {
                                "name": "JUPYTERHUB_SERVICE_NAME",
                                "value": "jupyterhub"
                            },
                            {
                                "name": "JUPYTERHUB_NOTEBOOK_IMAGE",
                                "value": "{{ notebook_image }}"
                            },
                            {
                                "name": "JUPYTERHUB_NOTEBOOK_MEMORY",
                                "value": "{{ notebook_memory }}"
                            },
                            {
                                "name": "JUPYTERHUB_DATABASE_PASSWORD",
                                "value": "{{ db_password }}"
                            },
                            {
                                "name": "JUPYTERHUB_DATABASE_HOST",
                                "value": "jupyterhub-db"
                            },
                            {
                                "name": "JUPYTERHUB_COOKIE_SECRET",
                                "value": "{{ cookie_secret }}"
                            },
                            {
                                "name": "JUPYTERHUB_STORAGE_CLASS",
                                "value": "{{ storage_class }}"
                            },
                            {
                                "name": "APP_SCRIPT",
                                "value": "/opt/app-root/builder/run"
                            },
                            {
                                "name": "GPU_MODE",
                                "value": "{{ gpu_mode }}"
                            },
                            {
                                "name": "JUPYTERHUB_ADMIN_USERS",
                                "value": "{{ jupyterhub_admins|join(',') }}"
                            },
                            {
                                "name": "SINGLEUSER_PVC_SIZE",
                                "value": "{{ user_pvc_size }}"
                            }
                        ],
                        "volumeMounts": [
                            {
                                "name": "config",
                                "mountPath": "/opt/app-root/configs"
                            }
                        ]
                    }
                ],
                "volumes": [
                    {
                        "name": "config",
                        "configMap": {
                            "name": "{{ jupyterhub_configmap_name }}",
                            "defaultMode": 420
                        }
                    }
                ]
            }
        }
    }
}
